<CsoundSynthesizer>
<CsOptions>
-n -m0
</CsOptions>
<CsInstruments>

  opcode StraySetEl, 0, Sojpjj
;puts the string decoded by the strset number istrin (default=0) at the position ielindx (default=-1: at the end) of Stray, and returns the result again as a strset number istrout (default=1). elements in the string are seperated by the two ascii-coded seperators isepA (default=32: space) and isepB (default=9: tab). if just isepA is given, it is also read as isepB
Stray, istrin, ielindx, istrout, isepA, isepB xin
;;DEFINE THE SEPERATORS
isep1		=		(isepA == -1 ? 32 : isepA)
isep2		=		(isepA == -1 && isepB == -1 ? 9 : (isepB == -1 ? isep1 : isepB))
Sep1		sprintf	"%c", isep1
Sep2		sprintf	"%c", isep2
;;INITIALIZE SOME PARAMETERS
Sin		strget		istrin
ilen		strlen		Stray
iel		=		0; actual element position
iwarsep	=		1
indx		=		0
;;APPEND Sin IF ielindx=-1
 if ielindx == -1 then
Sres		sprintf	"%s%s%s", Stray, Sep1, Sin
		igoto		end	
  endif
;;PREPEND Sin IF ielindx=0
 if ielindx == 0 then
Sres		sprintf	"%s%s%s", Sin, Sep1, Stray
		igoto		end	
  endif
loop:
Snext		strsub		Stray, indx, indx+1; next sign
isep1p		strcmp		Snext, Sep1; returns 0 if Snext is sep1
isep2p		strcmp		Snext, Sep2; 0 if Snext is sep2
;;NEXT SIGN IS NOT SEP1 NOR SEP2
if isep1p != 0 && isep2p != 0 then
 if iwarsep == 1 then; first character after a seperator 
  if iel == ielindx then; if searched element index
S1		strsub		Stray, 0, indx; string before Sin
S2		strsub		Stray, indx, -1; string after Sin
Sres		sprintf	"%s%s%s%s", S1, Sin, Sep1, S2
		igoto		end
  else 			;if not searched element index
iel		=		iel+1; increase it
iwarsep	=		0; log that it's not a seperator 
  endif 
 endif 
;;NEXT SIGN IS SEP1 OR SEP2
else 
iwarsep	=		1
endif
		loop_lt	indx, 1, ilen, loop 
;;APPEND Sin IF ielindx is >= number of elements
Sres		sprintf	"%s%s%s", Stray, Sep1, Sin
end:		strset		istrout, Sres
  endop 

instr 1
Stray 		strget 	p4
		strset		p5, "bubu"
ipcnt		pcount
;print ipcnt
if ipcnt == 4 then
		StraySetEl	Stray
elseif ipcnt == 5 then
		StraySetEl	Stray, p5
elseif ipcnt == 6 then
		StraySetEl	Stray, p5, p6
elseif ipcnt == 7 then
		StraySetEl	Stray, p5, p6, p7
elseif ipcnt == 8 then
		StraySetEl	Stray, p5, p6, p7, p8
else
		StraySetEl	Stray, p5, p6, p7, p8, p9
endif		
istrout	=		(p7 == 0 ? 1 : p7)
Sres		strget		istrout
		printf_i	"'%s'\n", 1, Sres
endin 

</CsInstruments>
<CsScore>
i 1 0 0 "the number 1 is not a"
i . 0 0 "the number 1 is not a" 0 1
i . 0 0 "the number 1 is not a" 0 2
i . 0 0 "the number 1 is not a" 0 3
i . 0 0 "the number 1 is not a" 0 4
i . 0 0 "the number 1 is not a" 0 5
i . 0 0 "the number 1 is not a" 0 6
i . 0 0 "the number 1 is not a" 0 60
i . 0 0 "The		ASCII code of a comma (,) is 44" 10 1 100
i . 0 0 "The		ASCII code of a comma (,) is 44" 0 1 1 32
i . 0 0 "The		ASCII code of a comma (,) is 44" 0 1 1 32 9
i . 0 0 "The		ASCII code of a comma (,) is 44" 0 1 1 44 !
i . 0 0 "The		ASCII code of a comma (,) is 44" 0 1 1 9 44
i . 0 0 "The		ASCII code of a comma (,) is 44" 0 2 1 9 44
e
</CsScore>
</CsoundSynthesizer>

